// keyb.h
//
// TV Remote controller project for Motorola68HC908QY4
// Based on SDCC M08 Port Compiler & Library
// By Sarosi, 2004.03.07, Free
//
#ifndef KEYB_H
#define KEYB_H 1

#include "rc.h"

extern unsigned char _near key;

#define KEY_0 0
#define KEY_1 1
#define KEY_2 2
#define KEY_3 3
#define KEY_4 4
#define KEY_5 5
#define KEY_6 6
#define KEY_7 7
#define KEY_8 8
#define KEY_9 9

#define KEY_L 10  // left
#define KEY_U 11  // up
#define KEY_R 12  // right
#define KEY_X 13  // extra X
#define KEY_D 14  // down
#define KEY_Y 15  // extra y

#define KEY_XA 16 // compound A
#define KEY_XB 17 // compound B
#define KEY_XC 18 // compound C
#define KEY_XD 19 // compound D


void KeyInit(void);
unsigned char KeyInRow(unsigned char base);
unsigned char KeyInMatrix(void);
unsigned char GetKey(void);
void Keyboard_IT(void) interrupt 0xffE0;
#endif

// end of keyb.h

