// rc.c
//
// TV Remote controller project for Motorola68HC908QY4
// Based on SDCC M08 Port Compiler & Library
// By Sarosi, 2004.03.07, Free
//

#include "mc68hc908qy.h"
#include "rc.h"
#include "keyb.h"
#include "tda1250.h"
#include "serial.h"
#include "delay.h"


unsigned char _near b;  // for bit indexing
unsigned int  _near w;  // for bit shifting

void Monitor(void);

void Blink(char count){
   DDRA3 = 1;
   while(count){
      PTA3 = 0;
      DelayMs(300);
      PTA3= 1;
      DelayMs(300);
      count--;
   }
   //DelayMs(600);
   DDRA3 = 0;
}


//-----------------------------------------------
//-----------------------------------------------
void main(void) {
   //unsigned int cd;
   char i;
#define MAIN_TYPE 1

   CONFIG1 = 0x00  /* disable COP */
           | 0x02  /* STOP can be used */
           | 0x00  /* SSREC: long STOP recovery */
           | 0x00  /* 0x008 - LVI5OR3: 5V LVI usage */
           ;

   CONFIG2 = 0x00; /* default (int. osc.) */

   //load the TRIM value stored in FLASH
   if( OSCTRIMVAL != 0xFF ){
     OSCTRIM = OSCTRIMVAL;
   }

   DebPuts("Ir Remote Controler for 68HC908QY4\nV0.04/SaJo/2004 \n");

#if MAIN_TYPE==10
   DDRA3=1;
   while(1) {
      PTA3 = 0;
      DelayMs(20000);
      PTA3= 1;
      DelayMs(20000);
   }
#endif



#if MAIN_TYPE==1
   while(1) {
      
      unsigned int ad;
      unsigned int cd;
      
      for(ad=0x040; ad<0x400; ad += 0x040){
         for( cd=0; cd<8; cd++){
            
         TDA1250_code(ad|cd);

         PTA3 = 0;
         DDRA3=1;
         DelayMs(70);
         PTA3= 1;
         DDRA3=0;
         DelayMs(500);
         }
      }
   }
#endif

#if MAIN_TYPE==2

   //DDRA3 = 1;
   Monitor();

   // setup keyboard (IT disabled)
   KeyInit();

   // the main cycle
   while(1) {
      
      COPCTL=0;
      
         // scan rows one by one
         PTB0=0; PTB1=1; PTB2=1; PTB3=1;
         i = KeyInRow(0);  // [1,2,3,4]
         PTB0=0; PTB1=0; PTB2=0; PTB3=0;
      
         DebPutByte('A'+i);

      // work on key (presented by keyboard IT)
      switch( key ){
      case 0: // no key at all
              break;

      default: DebPutByte(' '+i);
      }

      // prepare keyboard logic
      IMASKK = 1;   // disable IT
      ACKK   = 1;   // Clear pending status
      key    = 0;
      //IMASKK = 0;   // enable IT (it get out of stop)

      // get into stop mode (keyboard IT activated)
      DebPutByte('S');
      _asm
         stop
      _endasm;
      DebPutByte('W');
   }
#endif


#if MAIN_TYPE==3
{
   unsigned char uc, puc;
   Monitor();

   // the main cycle
   PTB0=1; PTB1=0; PTB2=1; PTB3=1;
   DDRB0=1; DDRB1=1; DDRB2=1; DDRB3=1;

   uc = PTA & 0x0c;
   puc = uc;
   DebPutB(uc);
   DebPutByte('\r');
      
   while(1) {
      COPCTL=0;
      uc = PTA & 0x0c;
      if( puc != uc ){
         puc = uc;
         DebPutB(uc);
         DebPutByte('\r');
      }
   }
}
#endif

}


