/*
** libgcc support for software floating point.
** Copyright (C) 1991 by Pipeline Associates, Inc.  All rights reserved.
** Permission is granted to do *anything* you want with this file,
** commercial or otherwise, provided this message remains intact.  So there!
** I would appreciate receiving any updates/patches/changes that anyone
** makes, and am willing to be the repository for said changes (am I
** making a big mistake?).
**
** Pat Wood
** Pipeline Associates, Inc.
** pipeline!phw@motown.com or
** sun!pipeline!phw or
** uunet!motown!pipeline!phw
*/

#include <float.h>

/* packs float       6,x     7..8.x    9..10.x */
/* packs float       0,x     7..8.x    9..10.x */
float __fs_pack(char sign, int exp, long *mant ){

  sign+0;
  exp +0;
  mant+0;
   
  _asm
        psha          //save sign

        tsx
        lda  9,x
        ldx  10,x
        psha
        pulh

        lda	3,x   //LSB
	sta	7,sp
	lda	2,x
	sta	6,sp
	lda	1,x
	and     #0x7F
        tsx
	sta	4,x

	lda     8,x   // put exponent bit 0. to the hidden bit position
	rora
	clra
	rora
	ora     4,x
	sta     4,x

	rol     ,x    // mix sign and exponent
	lda     8,x
	rora
	sta     3,x

	pulh
	rts 
  _endasm;

  return 0; 
}

