/*-------------------------------------------------------------------------
  _mulint.c :- routine for (unsigned) int (16 bit) multiplication

             Written By -  Sandeep Dutta . sandeep.dutta@usa.net (1999)

   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU Library General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   In other words, you are welcome to use, share and improve this program.
   You are forbidden to forbid anyone else to use, share and improve
   what you give them.   Help stamp out software-hoarding!
-------------------------------------------------------------------------*/

/* Signed and unsigned multiplication are the same - as long as the output
   has the same precision as the input.
*/


union uu {
	struct { unsigned char hi,lo;} s;
        unsigned int t;
};

int _mulint (int a, int b);

int _mulint (int a, int b) {

#define ucast(a) ((union uu *)&a)

  union uu t;

  t.t = ucast(a)->s.lo * ucast(b)->s.lo;
  t.s.hi += (unsigned char)(ucast(a)->s.lo * ucast(b)->s.hi);
  t.s.hi += (unsigned char)(ucast(b)->s.lo * ucast(a)->s.hi);
  return t.t;
}
